#!/usr/bin/env ruby
#  it's generally considered a better design if mixins rely on 
# attributes (getter and setter methods) rather than instance variables. 
# That way, if an instance variable changes it doesn't break the mixin.

module StudioGame
    module Playable
        def w00t
            puts "#{name} got w00ted!".center(40)
            self.health += 15
        end

        def blam
            puts "#{name} got blammed!".center(40)
            self.health -= 10
        end

        def strong?
            self.health > 100 ? true : false
        end

        def weak?
            self.health <= 100 ? true : false
        end
    end
end