#!/usr/bin/ruby
require_relative 'playable'

module StudioGame
    class Player
        include Playable
        attr_accessor :name, :health, :score
        def initialize name, health=100, score=0
            @name = name.capitalize
            @health = health
            @found_treasures = Hash.new(0)
            @score = @name.length + @health
        end

        def to_s
            "I'm #{@name} with a health of #{@health} and a score of #{score}"
        end

        def random_score
            rand(1..100)
        end
        def use_special_attack opponent
            if opponent.health
                value = random_score
                opponent.health -= value
                puts "Special attack used on #{opponent.name}"
            else
                puts "Cannot attack this player"
            end
        end

        def <=> other
            other.score <=> @score
        end

        def points
            @found_treasures.values.reduce(0, :+)
        end

        def score 
            @health + points
        end

        def found_treasure treasure
            puts "#{@name} found a #{treasure.name} worth #{treasure.points}.".center(40)
            @found_treasures[treasure.name] += treasure.points
            puts "#{@name}'s treasures #{@found_treasures}.".center(40)
        end

        def each_found_treasure
            @found_treasures.each do |name, points|
                yield Treasure.new(name, points)
            end
        end
    end
end