#!/usr/bin/ruby
require_relative 'player'
require_relative 'treasure_trove'

module StudioGame
    class SuperBossPlayer < Player
        def initialize name, health=100
            super(name, health)
            @w00t_count = 0
        end

        def berserk?
            @w00t_count >= 5
        end

        def w00t
            super
            @w00t_count += 1
            puts "#{@name} is berserk! Health will increase if blammed." if berserk?
        end
        def blam
            berserk? ? w00t : super
        end
        def found_treasure treasure
            points = treasure.points * 1000
            boss_treasure = Treasure.new(treasure.name, points)
            super boss_treasure
        end
    end
end

if __FILE__ == $0
    boss = SuperBossPlayer.new("matt")  
    
    hammer = Treasure.new(:hammer, 50)
    boss.found_treasure(hammer)
    boss.found_treasure(hammer)
    boss.found_treasure(hammer)
    
    bazooka = Treasure.new(:bazooka, 400)
    boss.found_treasure(bazooka)
    
    boss.each_found_treasure do |treasure|
      puts "#{treasure.points} total #{treasure.name} points"
    end
    puts "#{boss.points} grand total points"
    puts "#{boss.health} total health"
    5.times {boss.w00t}
    puts "#{boss.health} total health"
    2.times {boss.blam}
    puts "#{boss.health} total health"
end